Subject: Re: Generating GNU-style Changelog from git commits

From: Chris Packham <[email-masked]>
Date: Sun, 17 Apr 2011 12:53:33 +1200

On 17/04/11 10:46, David Chanters wrote:
> [Please Cc me on replies.  Thanks!]
>
> Hi,
>
> Some projects maintain a ChangeLog file, which looks something like this:
>
> 2011-01-01  David Chanters<[email-masked]>
>          * foo/bar.c (some_function):
>           Changed static variable in some_function to auto.
>
> etc., etc.
>
> Here "foo" is some directory relative to the top-level directory the
> .git one is in.
>
> These ChangeLog files are maintained manually, irrespective of the/any
> revision control system in use.  I am wondering if it's possible if
> the project is in Git to be able to automatically append to such a
> ChangeLog file with each commit automatically, and have it formatted
> in the style above.
>
> Is this possible?  Is it a solved problem?  If not, and I wanted to
> try myself, could someone point me at the git-specific tools I'd need
> to know to use to achieve it?
>
> TIA!
> DC
> --

Shouldn't be to hard, there are numerous hooks that could be used either 
on the developer end (post-commit), on the server end (post-update) or 
even when a maintainer applies a patch (post-applypatch). See 
githooks(5) for more info on what hooks are available and what args are 
passed.

There is also the possibility of generating this changelog at the time 
of release. I'd advocate this approach as it would allow you to edit the 
changelog to make it more useful to readers.

Either way the actual format could probably be generated with 'git log 
--format' (someone else may reply with better plumbing commands, but my 
initial response is use git log).

My 2 minutes worth of reading git-log(1) got me this

   git log --format="%ai%x09%an <%ae> %n%x09* %s" REVISIONS

Which for a chunk of gits pu branch gave me this (my mail client munges 
some of the longer lines)

2011-02-17 13:54:28 -0800	Junio C Hamano <[email-masked]>
	* Merge branch 'js/cherry-pick-usability' into pu
2011-02-17 12:29:33 -0800	Junio C Hamano <[email-masked]>
	* Merge branch 'so/submodule-no-update-first-time' into pu
2011-02-17 12:29:32 -0800	Junio C Hamano <[email-masked]>
	* Merge branch 'jc/grep--no-index-pathspec-fix' into pu
2011-02-17 09:18:46 -0700	Spencer E. Olson <[email-masked]>
	* t7406: "git submodule update {--merge|--rebase]" with new submodules
2011-02-17 09:18:45 -0700	Spencer E. Olson <[email-masked]>
	* submodule: no [--merge|--rebase] when newly cloned
2011-02-16 14:39:00 -0800	Junio C Hamano <[email-masked]>
	* grep --no-index: honor pathspecs correctly
2011-02-16 05:08:23 -0500	Jay Soffian <[email-masked]>
	* Teach commit about CHERRY_PICK_HEAD
2011-02-16 12:20:35 -0500	Jay Soffian <[email-masked]>
	* Introduce CHERRY_PICK_HEAD

Which is pretty close. You could experiment with more format specifiers 
to get the info you need.

Hope that helps
- Chris